-- TurretHop 1.2 by AbortRetryFail

local lockout = Timer()
local targetcache = {}

local function GetTurret(turret)
	local turretnames = GetTurretNamesByStationType(GetStationType())
	local sti = GetStationTurretInfo(turret)
	if not sti then return end -- bail out!
	sectorprint("Switching to turret: "..tostring(turret)..": "..tostring(turretnames[sti.itemid]).." ("..InvManager.GetInventoryItemParameter(sti.itemtype, "Name")..")")
	PurchaseMerchandiseItem(sti.itemid)
	radar.SetRadarSelection(unpack(targetcache))
end

local function HUD_SHOW(event, data)
	if data and data == "turret" then
		radar.SetRadarSelection(unpack(targetcache))
	end
end
RegisterEvent(HUD_SHOW, "HUD_SHOW")

function TurretHop(_, args)
	if lockout:IsActive() then return end
	targetcache = {radar.GetRadarSelectionID()} 
	local numturrets = GetNumStationTurrets()
	local turret = tonumber(args[1])
	if numturrets and turret and turret >= 1 and turret <= numturrets then
		if HUD.hudtype == "turret" then
			gkinterface.GKProcessCommand("Activate")
			lockout:SetTimeout(384, function() return end) -- Sometimes /activate takes a bit too long to switch out of the turret.
		end
		GetTurret(turret)
	end
end

RegisterUserCommand("turrethop", TurretHop)
